Weiterbildung/src/main/java/org/infai/ddls/medicaltraining/model/Doctor.java
package org.infai.ddls.medicaltraining.model;

import javax.persistence.MappedSuperclass;

import org.hibernate.envers.Audited;

@MappedSuperclass
@Audited
public abstract class Doctor extends Person {
}

Weiterbildung/src/main/java/org/infai/ddls/medicaltraining/model/Person.java
package org.infai.ddls.medicaltraining.model;

import java.beans.Transient;
import java.time.LocalDate;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.validation.Valid;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Past;

import org.hibernate.envers.Audited;
import org.infai.ddls.medicaltraining.json.View;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateSerializer;

@Entity
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
@Audited
public abstract class Person extends TrainingAppEntity {
    @Past
    @JsonDeserialize(using = LocalDateDeserializer.class)
    @JsonSerialize(using = LocalDateSerializer.class)
    private LocalDate birthDate;
    @NotBlank
    @Column(nullable = false)
    @JsonView(View.Summary.class)
    private String lastName;
    @NotNull
    @Valid
    @Embedded
    @Column(nullable = false)
    private Address address;
    @Valid
    @Embedded
    private ContactInfo contactInfo;
    @Valid
    @ManyToOne
    private Sex sex;
    @Valid
    @ManyToOne
    private Title title;
    @OneToMany(mappedBy = "contact")
    private List<Contact> contacts;

    public Person() {
	this.address = new Address();
	this.contactInfo = new ContactInfo();
    }

    public Address getAddress() {
	return address;
    }

    public LocalDate getBirthDate() {
	return birthDate;
    }

    public ContactInfo getContactInfo() {
	return contactInfo;
    }

    public List<Contact> getContacts() {
	return contacts;
    }

    @Transient
    public String getFullName() {
	return getName() + " " + getLastName();
    }

    public String getLastName() {
	return lastName;
    }

    public Sex getSex() {
	return sex;
    }

    public Title getTitle() {
	return title;
    }

    public void setAddress(Address address) {
	this.address = address;
    }

    public void setBirthDate(LocalDate birthDate) {
	this.birthDate = birthDate;
    }

    public void setContactInfo(ContactInfo contactInfo) {
	this.contactInfo = contactInfo;
    }

    public void setContacts(List<Contact> contacts) {
	this.contacts = contacts;
    }

    public void setLastName(String lastName) {
	this.lastName = lastName;
    }

    public void setSex(Sex sex) {
	this.sex = sex;
    }

    public void setTitle(Title title) {
	this.title = title;
    }

    @Override
    public String toString() {
	return getFullName();
    }
}

Weiterbildung/src/main/java/org/infai/ddls/medicaltraining/controller/DoctorController.java
package org.infai.ddls.medicaltraining.controller;

import java.time.LocalDate;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletRequest;

import org.infai.ddls.medicaltraining.model.AuthorisationField;
import org.infai.ddls.medicaltraining.model.AuthorisedDoctor;
import org.infai.ddls.medicaltraining.model.Registrar;
import org.infai.ddls.medicaltraining.model.RotationPlanSegment;
import org.infai.ddls.medicaltraining.model.TrainingPositionField;
import org.infai.ddls.medicaltraining.spec.AuthorisedDoctorFilter;
import org.infai.ddls.medicaltraining.spec.RegistrarFilter;
import org.infai.ddls.medicaltraining.spec.TrainingPositionFieldFilter;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;

@Controller
public class DoctorController extends AbstractMedicalTrainingController {
    public static final String VIEW_REGISTRARS_LIST = "doctors/listRegistrars";
    public static final String VIEW_REGISTRARS_EDIT = "doctors/editRegistrar";
    public static final String VIEW_AUTHORISED_DOCTORS_LIST = "doctors/listAuthorisedDoctors";
    public static final String VIEW_AUTHORISED_DOCTORS_EDIT = "doctors/editAuthorisedDoctor";

    public static final String editAuthorisation(Long authorisedDoctorUId, Long authorisationUId) {
	return "/doctors/authoriseddoctors/" + authorisedDoctorUId + "/authorisations/" + authorisationUId + "/edit";
    }

    public static final String editAuthorisedDoctor(Long authorisedDoctorUId) {
	return "/doctors/authoriseddoctors/" + authorisedDoctorUId + "/edit";
    }

    @GetMapping("doctors/authoriseddoctors/{authorisedDoctorUID}/authorisations/create")
    public String createAuthorisation(@PathVariable long authorisedDoctorUID, Model model) {
	AuthorisationField authorisationField = new AuthorisationField();
	authorisationField.setAuthorisedDoctor(personDAO.getAuthorisedDoctor(authorisedDoctorUID, true, true));

	return editAuthorisation(authorisationField, model);
    }

    @GetMapping(RequestMappings.AUTHORISED_DOCTORS_CREATE)
    public String createAuthorisedDoctor(Model model) {
	return editAuthorisedDoctor(new AuthorisedDoctor(), model);
    }

    @GetMapping(RequestMappings.REGISTRARS_CREATE)
    public String createRegistrar(Model model) {
	return editRegistrar(new Registrar(), model);
    }

    @PostMapping("doctors/authoriseddoctors/{uid}/delete")
    public String deleteAuthorisedDoctorPerform(@PathVariable("uid") long uid, Model model) {
	if (personDAO.delete(personDAO.getAuthorisedDoctor(uid, false, false), true, true, true)) {
	    return redirect(RequestMappings.AUTHORISED_DOCTORS_LIST);
	} else {
	    return null;
	}
    }

    @GetMapping("doctors/authoriseddoctors/{uid}/delete")
    public String deleteAuthorisedDoctorVerify(@PathVariable("uid") long uid, Model model) {
	AuthorisedDoctor authorisedDoctor = personDAO.getAuthorisedDoctor(uid, false, true);

	TrainingPositionFieldFilter trainingPositionFieldFilter = new TrainingPositionFieldFilter();
	trainingPositionFieldFilter.setAuthorisedDoctor(authorisedDoctor);
	List<TrainingPositionField> positions = trainingPositionDAO.getTrainingPositionsField(trainingPositionFieldFilter, null);

	Map<TrainingPositionField, List<RotationPlanSegment>> segments = new HashMap<>();
	for (TrainingPositionField position : positions) {
	    segments.put(position, rotationPlanDAO.getRotationPlanSegments(position, null));
	}

	model.addAttribute("authorisedDoctor", authorisedDoctor);
	model.addAttribute("trainingPositions", segments);

	return "doctors/deleteAuthorisedDoctor";
    }

    @GetMapping("doctors/authoriseddoctors/{authorisedDoctorUID}/authorisations/{authorisationUID}/edit")
    public String editAuthorisation(@PathVariable long authorisedDoctorUID, @PathVariable long authorisationUID, Model model) {
	return editAuthorisation(authorisationDAO.getAuthorisationField(authorisationUID), model);
    }

    @GetMapping(RequestMappings.AUTHORISED_DOCTORS_EDIT)
    public String editAuthorisedDoctor(@PathVariable long uid, Model model) {
	return editAuthorisedDoctor(personDAO.getAuthorisedDoctor(uid, true, true), model);
    }

    @GetMapping(RequestMappings.REGISTRARS_EDIT)
    public String editRegistrar(@PathVariable long uid, Model model) {
	return editRegistrar(personDAO.getRegistrar(uid), model);
    }

    @PostMapping("doctors/authoriseddoctors/filter")
    public String filterAuthorisedDoctors(@ModelAttribute("authorisedDoctorFilter") @Validated AuthorisedDoctorFilter authorisedDoctorFilter, BindingResult bindingResult, Model model, Pageable pageable, ServletRequest servletRequest) {
	return listAuthorisedDoctors(personDAO.getAuthorisedDoctors(authorisedDoctorFilter, pageable.getSort(), true), authorisedDoctorFilter, model);
    }

    @GetMapping(RequestMappings.AUTHORISED_DOCTORS_LIST)
    public String listAuthorisedDoctors(Model model, Pageable pageable) {
	return listAuthorisedDoctors(personDAO.getAuthorisedDoctors(pageable.getSort(), true), new AuthorisedDoctorFilter(), model);
    }

    @GetMapping(RequestMappings.REGISTRARS_LIST)
    public String listRegistrars(Model model, Pageable pageable) {
	return listRegistrars(personDAO.getRegistrars(pageable.getSort()), new RegistrarFilter(), model);
    }

    @GetMapping("doctors/registrars/{registrarUId}/archive")
    public String registrarArchive(@PathVariable long registrarUId, Model model) {
	Registrar registrar = personDAO.getRegistrar(registrarUId);
	registrar.setArchived(true);

	personDAO.save(registrar);

	return redirect(RequestMappings.REGISTRARS_LIST);
    }

    @PostMapping("doctors/registrars/filter")
    public String registrarFilter(@ModelAttribute("registrarFilter") @Validated RegistrarFilter registrarFilter, BindingResult bindingResult, Model model, Pageable pageable, ServletRequest servletRequest) {
	return listRegistrars(personDAO.getRegistrars(registrarFilter, pageable.getSort()), registrarFilter, model);
    }

    @PostMapping("doctors/authoriseddoctors/{authorisedDoctorUID}/authorisations/edit")
    public String updateAuthorisation(@PathVariable long authorisedDoctorUID, @ModelAttribute("authorisation") @Validated AuthorisationField authorisationField, BindingResult bindingResult, Model model, ServletRequest servletRequest) {
	System.out.println(formatHTTPParameters(servletRequest));
	if (bindingResult.hasErrors()) {
	    logger.warn(bindingResult.getAllErrors());

	    System.out.println(authorisationField.getAuthorisedDoctor());
	    authorisationField.setAuthorisedDoctor(personDAO.getAuthorisedDoctor(authorisedDoctorUID, false, false));
	    System.out.println(authorisationField.getAuthorisedDoctor());

	    return editAuthorisation(authorisationField, model);
	}

	System.out.println("speichere authorisation");
	System.out.println("\t" + authorisationField.getUid());
	System.out.println("\t" + authorisationField.getAuthorisedDoctor());

	authorisationField = authorisationDAO.save(authorisationField);

	System.out.println("authorisation gespeichert");
	System.out.println("\t" + authorisationField.getUid());
	System.out.println("\t" + authorisationField.getAuthorisedDoctor());

	if (isSave(servletRequest)) {
	    return redirect(editAuthorisation(authorisationField.getAuthorisedDoctor().getUid(), authorisationField.getUid()));
	} else if (isSaveAndClose(servletRequest)) {
	    return redirect(editAuthorisedDoctor(authorisationField.getAuthorisedDoctor().getUid()));
	} else {
	    throw new RuntimeException("Parameter saveAction not set or invalid");
	}
    }

    @PostMapping(RequestMappings.AUTHORISED_DOCTORS_UPDATE)
    public String updateAuthorisedDoctor(@ModelAttribute(MODELATTRIBUTE_AUTHORISED_DOCTOR) @Validated AuthorisedDoctor authorisedDoctor, BindingResult bindingResult, Model model, ServletRequest servletRequest) {
	if (personDAO.isLANRusedByOther(authorisedDoctor)) {
	    bindingResult.rejectValue("lanr", "lanr.inUse", "lanr.inUse");
	}

	if (bindingResult.hasErrors()) {
	    logger.info(bindingResult.getAllErrors());
	    return editAuthorisedDoctor(authorisedDoctor, model);
	}

	Map<String, String> additionalFields = evaluateAdditionalFields(servletRequest);
	authorisedDoctor.setAdditionalFields(additionalFields);

	personDAO.save(authorisedDoctor);

	if (isSave(servletRequest)) {
	    return editAuthorisedDoctor(authorisedDoctor, model);
	} else if (isSaveAndClose(servletRequest)) {
	    return redirect(RequestMappings.AUTHORISED_DOCTORS_LIST);
	} else {
	    throw new RuntimeException("Parameter saveAction not set or not valid!");
	}
    }

    @PostMapping(RequestMappings.REGISTRARS_UPDATE)
    public String updateRegistrar(@ModelAttribute(MODELATTRIBUTE_REGISTRAR) @Validated Registrar registrar, BindingResult bindingResult, Model model, ServletRequest servletRequest) {
	if (bindingResult.hasErrors()) {
	    logger.info(bindingResult.getAllErrors());
	    return editRegistrar(registrar, model);
	}

	Map<String, String> additionalFields = evaluateAdditionalFields(servletRequest);
	registrar.setAdditionalFields(additionalFields);

	personDAO.save(registrar);

	return redirect(RequestMappings.REGISTRARS_LIST);
    }

    private String editAuthorisation(AuthorisationField authorisationField, Model model) {
	model.addAttribute("authorisation", authorisationField);

	populateTrainingSchemes(model);

Weiterbildung/src/main/webapp/WEB-INF/pages/doctors/editAuthorisedDoctor.jsp
<%@ include file="/WEB-INF/pages/include/include.jsp"%>
<c:url var="post_url" value="/doctors/authoriseddoctors/update" />

<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Weiterbildungsbefugten bearbeiten</title>
<link rel="stylesheet" type="text/css" href="/medicaltraining/resources/styles.css">
</head>
<body>
	<%@ include file="/WEB-INF/pages/include/nav.jsp"%>

	<main> <form:form method="post" modelAttribute="authorisedDoctor" action="${post_url}">
		<form:errors />
		<fieldset>
			<legend>Weiterbildungsbefugten bearbeiten</legend>
			<c:if test="${not empty authorisedDoctor.uid}">
				<form:hidden path="uid" />
			</c:if>

			<%@ include file="/WEB-INF/pages/doctors/editPerson.jsp"%>
			<%@ include file="/WEB-INF/pages/doctors/include/formEditLANR.jsp"%>

			<fieldset>
				<legend>Weiterbildungsstätte</legend>
				<div style="float: left; margin-right:15px;">
					<c:set var="comparatorDepartment" value="${authorisedDoctor.trainingSites}" />
					<c:set var="path" value="trainingSites" />
					<c:set var="size" value="20" />
					<%@ include file="/WEB-INF/pages/trainingsites/include/selectTrainingSites.jsp"%>
				</div>
				<h3>Momentan zugewiesene Weiterbildungsstätten</h3>
				<ul>
					<c:forEach items="${authorisedDoctor.trainingSites}" var="trainingSite">
						<li><c:if test="${not empty trainingSite.parent}">
								${trainingSite.parent.name}:&nbsp;
							</c:if> ${trainingSite.name}</li>
					</c:forEach>
				</ul>
			</fieldset>
		</fieldset>

		<c:set var="entity" value="${authorisedDoctor}" />
		<%@ include file="/WEB-INF/pages/include/editAdditionalFields.jsp"%>

		<form:button name="saveAction" value="save">Speichern</form:button>
		<form:button name="saveAction" value="saveAndClose">Speichern und Schließen</form:button>

		<fieldset>
			<legend>Weiterbildungsbefugnisse bearbeiten</legend>
			<c:choose>
				<c:when test="${not empty authorisedDoctor.uid}">
					<table class="datatable">
						<thead>
							<tr>
								<th></th>
								<th></th>
								<th>Weiterbildungsstätte</th>
								<th>Fachgebiet</th>
								<th>Behandlungsart</th>
								<th>Beginn</th>
								<th>Ende</th>
								<th>Ordnung</th>
							</tr>
						</thead>
						<tbody>
							<c:forEach items="${authorisations}" var="authorisation">
								<tr>
									<td><a href="<c:url value='/doctors/authoriseddoctors/${authorisedDoctor.uid}/authorisations/${authorisation.uid}/edit'/>"><img src="${editButton}" /></a></td>
									<td><a href="<c:url value='/doctors/authoriseddoctors/${authorisedDoctor.uid}/authorisations/${authorisation.uid}/delete'/>"><img src="${deleteButton}" /></a></td>
									<td><c:if test="${not empty authorisation.trainingSite.parent}">
											<c:out value="${authorisation.trainingSite.parent.name}" />:&nbsp;
							</c:if> <c:out value="${authorisation.trainingSite.name}" /></td>
									<td>${authorisation.trainingSite.medicalField}</td>
									<td>${authorisation.trainingSite.treatmentType}</td>
									<td>${authorisation.grantedOn}</td>
									<td>${authorisation.grantedTo}</td>
									<td>${authorisation.trainingScheme.name}</td>
								</tr>
							</c:forEach>
						</tbody>
						<tfoot>
							<tr>
								<td colspan="8"><a href="<c:url value='/doctors/authoriseddoctors/${authorisedDoctor.uid}/authorisations/create'/>">neuen Datensatz einfügen</a></td>
							</tr>
						</tfoot>
					</table>
				</c:when>
				<c:otherwise>
					<p>Bitte zunächst speichern, um Befugnisse hinzuzufügen!</p>
				</c:otherwise>
			</c:choose>
		</fieldset>
	</form:form>


	<h2>Änderungshistorie</h2>
	<table class="datatable">
		<thead>
			<tr>
				<th>Revisionsnummer</th>
				<th>Änderungsart</th>
				<th>Änderung am</th>
				<th>Änderung von</th>
				<th>Geschlecht</th>
				<th>Titel</th>
				<th>Vorname</th>
				<th>Nachname</th>
				<th>Geburtsdatum</th>
				<th>LANR</th>
				<th>Adresse</th>
				<th>Kontaktdaten</th>
				<th>Anmerkungen</th>
				<th>Zusätzliche Felder</th>
			</tr>
		</thead>
		<tbody>
			<c:forEach items="${revisions}" var="revision">
				<jsp:useBean id="dateValue" class="java.util.Date" />
				<jsp:setProperty name="dateValue" property="time" value="${revision.userRevision.timestamp}" />
				<tr>
					<td>${revision.userRevision.id}</td>
					<td>${revision.revisionTypeText}</td>
					<td><fmt:formatDate value="${dateValue}" pattern="dd.MM.yyyy - HH:mm:ss" /></td>
					<td>${revision.userRevision.userName}</td>
					<td>${revision.revisionEntity.sex.name}</td>
					<td>${revision.revisionEntity.title.name}</td>
					<td>${revision.revisionEntity.name}</td>
					<td>${revision.revisionEntity.lastName}</td>
					<td>${revision.revisionEntity.birthDate}</td>
					<td>${revision.revisionEntity.lanr}</td>
					<td>${revision.revisionEntity.address}</td>
					<td>${revision.revisionEntity.contactInfo}</td>
					<td>${revision.revisionEntity.notes}</td>
					<td>${revision.revisionEntity.additionalFields}</td>
				</tr>
			</c:forEach>
		</tbody>
	</table>
	</main>
</body>
</html>

Weiterbildung/src/main/webapp/WEB-INF/pages/doctors/editPerson.jsp
<%@ include file="/WEB-INF/pages/include/include.jsp"%>

<spring:message code="firstName" var="firstNamePlaceholder" />
<spring:message code="lastName" var="lastNamePlaceholder" />

<fieldset>
	<legend>
		<spring:message code="personalData" />
	</legend>
	<form:label path="sex">
		<spring:message code="sex" />
		<form:select path="sex">
			<form:option value="" label="------------" />
			<form:options itemValue="uid" itemLabel="name" items="${sexes}" />
		</form:select>
	</form:label>
	<form:label path="title">
		<spring:message code="title" />
		<form:select path="title">
			<form:option value="" label="------------" />
			<form:options itemValue="uid" itemLabel="name" items="${titles}" />
		</form:select>
	</form:label>
	<br />
	<form:label path="name">
		<spring:message code="firstName" />
		<form:input path="name" placeholder="${firstNamePlaceholder}" cssErrorClass="error" />
	</form:label>
	<form:label path="lastName">
		<spring:message code="lastName" />
		<form:input path="lastName" placeholder="${lastNamePlaceholder}" cssErrorClass="error" />
	</form:label>
	<br />
	<form:label path="birthDate">
		<spring:message code="birthDate" />
		<form:input path="birthDate" type="date" />
	</form:label>

	<form:errors path="name" cssClass="error" />
	<form:errors path="lastName" cssClass="error" />
</fieldset>

<%@ include file="/WEB-INF/pages/location/formEditAddressData.jsp"%>
<%@ include file="/WEB-INF/pages/include/editContactData.jsp"%>


<fieldset>
	<legend>
		<spring:message code="notes" />
	</legend>
	<form:textarea path="notes" style="width:100%; height:7.5em;" />
</fieldset>

Weiterbildung/src/main/webapp/WEB-INF/pages/doctors/listAuthorisedDoctors.jsp
<%@ include file="/WEB-INF/pages/include/include.jsp"%>
<c:url var="filterAuthorisedDoctors" value="/doctors/authoriseddoctors/filter" />


<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Übersicht Weiterbildungsbefugte</title>
<link rel="stylesheet" type="text/css" href="/medicaltraining/resources/styles.css">
</head>
<body>
	<%@ include file="/WEB-INF/pages/include/nav.jsp"%>

	<main> <form:form method="post" modelAttribute="authorisedDoctorFilter" action="${filterAuthorisedDoctors}">
		<fieldset>
			<legend>
				<spring:message code="authorisedDoctors.filter" />
			</legend>
			<form:label path="name">Name</form:label>
			<form:input path="name" />
			<form:label path="lanr">LANR</form:label>
			<form:input path="lanr" />
			<form:label path="addressText">Adresse</form:label>
			<form:input path="addressText" />
			<form:button>Suchen</form:button>
		</fieldset>
	</form:form>

	<fieldset>
		<legend>Übersicht Weiterbildungsbefugte</legend>
		<table class="datatable">
			<thead>
				<tr>
					<th></th>
					<th></th>
					<th>LANR</th>
					<th>Name</th>
					<th>Geburtsdatum</th>
					<th>Weiterbildungsstätte</th>
				</tr>
			</thead>
			<tbody>
				<c:forEach items="${authorisedDoctors}" var="authorisedDoctor">
					<tr>
						<td><a href="<c:url value='/doctors/authoriseddoctors/${authorisedDoctor.uid}/edit'/>"><img src="${editButton}" /></a></td>
						<td><a href="<c:url value='/doctors/authoriseddoctors/${authorisedDoctor.uid}/delete'/>"><img src="${deleteButton}" /></a></td>
						<td>${authorisedDoctor.lanr }</td>
						<td>${authorisedDoctor.sex.defaultPrefix}&nbsp;${authorisedDoctor.title.name}&nbsp;${authorisedDoctor.fullName}</td>
						<td><tags:localDate date="${authorisedDoctor.birthDate}" pattern="dd.MM.yyyy" /></td>
						<td><c:forEach items="${authorisedDoctor.trainingSites}" var="trainingSite" varStatus="i">
								<c:if test="${i.index gt 0}">
									<br />
								</c:if>
								<c:if test="${not empty trainingSite.parent }">
									<c:out value="${trainingSite.parent.name}" />:&nbsp;</c:if>
								<c:out value="${trainingSite.name}" />
							</c:forEach></td>
					</tr>
				</c:forEach>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="6"><a href="<c:url value='/doctors/authoriseddoctors/create'/>">neuen Datensatz anlegen</a></td>
				</tr>
			</tfoot>
		</table>
	</fieldset>
	</main>
</body>
</html>